package com.ejie.ab63.model;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Ab6341s00  
 * 
 *  
 */

public class HabitacionVivienda implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private String idHabVivienda;
	private EstablecimientoData establecimientoData;
	private BigDecimal supDormitorio;
	private String plazasHab;
	private String identHabitacion;
	private String accesible;
	private String ilumNatural;
	private String ventilacionPatio;
	private String usoTuristico;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;

	/**
	 * Method 'Ab6341s00'.
	 */
	public HabitacionVivienda() {
	}

	/**
	 * Method 'Ab6341s00'.
	 * 
	 * @param idHabVivienda
	 *            String
	 */
	public HabitacionVivienda(String idHabVivienda) {
		this.idHabVivienda = idHabVivienda;
	}

	/**
	 * Method 'Ab6341s00'.
	 * 
	 * @param idHabVivienda
	 *            String
	 * @param supDormitorio
	 *            String
	 * @param plazasHab
	 *            String
	 * @param identHabitacion
	 *            String
	 * @param accesible
	 *            String
	 * @param ilumNatural
	 *            String
	 * @param ventilacionPatio
	 *            String
	 * @param usoTuristico
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param ab6321s00
	 *            Ab6321s00
	 */
	public HabitacionVivienda(String idHabVivienda, BigDecimal supDormitorio, String plazasHab, String identHabitacion,
			String accesible, String ilumNatural, String ventilacionPatio, String usoTuristico, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion,
			EstablecimientoData ab6321s00) {

		this.idHabVivienda = idHabVivienda;
		this.establecimientoData = ab6321s00;
		this.supDormitorio = supDormitorio;
		this.plazasHab = plazasHab;
		this.identHabitacion = identHabitacion;
		this.accesible = accesible;
		this.ilumNatural = ilumNatural;
		this.ventilacionPatio = ventilacionPatio;
		this.usoTuristico = usoTuristico;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdHabVivienda'.
	 *
	 * @return String
	 */

	public String getIdHabVivienda() {
		return this.idHabVivienda;
	}

	/**
	 * Method 'setIdHabVivienda'.
	 *
	 * @param idHabVivienda
	 *            String
	 * @return
	 */

	public void setIdHabVivienda(String idHabVivienda) {
		this.idHabVivienda = idHabVivienda;
	}

	/**
	 * Method 'getAb6321s00'.
	 *
	 * @return Ab6321s00
	 */
	@JsonIgnore

	public EstablecimientoData getEstablecimientoData() {
		return this.establecimientoData;
	}

	/**
	 * Method 'setAb6321s00'.
	 *
	 * @param ab6321s00
	 *            Ab6321s00
	 * @return
	 */

	public void setEstablecimientoData(EstablecimientoData ab6321s00) {
		this.establecimientoData = ab6321s00;
	}

	/**
	 * Method 'getSupDormitorio'.
	 *
	 * @return String
	 */

	public BigDecimal getSupDormitorio() {
		return this.supDormitorio;
	}

	/**
	 * Method 'setSupDormitorio'.
	 *
	 * @param supDormitorio
	 *            String
	 * @return
	 */

	public void setSupDormitorio(BigDecimal supDormitorio) {
		this.supDormitorio = supDormitorio;
	}

	/**
	 * Method 'getPlazasHab'.
	 *
	 * @return String
	 */

	public String getPlazasHab() {
		return this.plazasHab;
	}

	/**
	 * Method 'setPlazasHab'.
	 *
	 * @param plazasHab
	 *            String
	 * @return
	 */

	public void setPlazasHab(String plazasHab) {
		this.plazasHab = plazasHab;
	}

	/**
	 * Method 'getIdentHabitacion'.
	 *
	 * @return String
	 */

	public String getIdentHabitacion() {
		return this.identHabitacion;
	}

	/**
	 * Method 'setIdentHabitacion'.
	 *
	 * @param identHabitacion
	 *            String
	 * @return
	 */

	public void setIdentHabitacion(String identHabitacion) {
		this.identHabitacion = identHabitacion;
	}

	/**
	 * Method 'getAccesible'.
	 *
	 * @return String
	 */

	public String getAccesible() {
		return this.accesible;
	}

	/**
	 * Method 'setAccesible'.
	 *
	 * @param accesible
	 *            String
	 * @return
	 */

	public void setAccesible(String accesible) {
		this.accesible = accesible;
	}

	/**
	 * Method 'getIlumNatural'.
	 *
	 * @return String
	 */

	public String getIlumNatural() {
		return this.ilumNatural;
	}

	/**
	 * Method 'setIlumNatural'.
	 *
	 * @param ilumNatural
	 *            String
	 * @return
	 */

	public void setIlumNatural(String ilumNatural) {
		this.ilumNatural = ilumNatural;
	}

	/**
	 * Method 'getVentilacionPatio'.
	 *
	 * @return String
	 */

	public String getVentilacionPatio() {
		return this.ventilacionPatio;
	}

	/**
	 * Method 'setVentilacionPatio'.
	 *
	 * @param ventilacionPatio
	 *            String
	 * @return
	 */

	public void setVentilacionPatio(String ventilacionPatio) {
		this.ventilacionPatio = ventilacionPatio;
	}

	/**
	 * Method 'getUsoTuristico'.
	 *
	 * @return String
	 */

	public String getUsoTuristico() {
		return this.usoTuristico;
	}

	/**
	 * Method 'setUsoTuristico'.
	 *
	 * @param usoTuristico
	 *            String
	 * @return
	 */

	public void setUsoTuristico(String usoTuristico) {
		this.usoTuristico = usoTuristico;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idHabVivienda: ").append(this.idHabVivienda).append(" ]");
		result.append(", [ supDormitorio: ").append(this.supDormitorio).append(" ]");
		result.append(", [ plazasHab: ").append(this.plazasHab).append(" ]");
		result.append(", [ identHabitacion: ").append(this.identHabitacion).append(" ]");
		result.append(", [ accesible: ").append(this.accesible).append(" ]");
		result.append(", [ ilumNatural: ").append(this.ilumNatural).append(" ]");
		result.append(", [ ventilacionPatio: ").append(this.ventilacionPatio).append(" ]");
		result.append(", [ usoTuristico: ").append(this.usoTuristico).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

}
